org.apache.tinkerpop.gremlin.process.traversal.step.sideEffect

## Class GroupSideEffectStep<S,K,V>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,S>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.sideEffect.SideEffectStep<S>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.sideEffect.GroupSideEffectStep<S,K,V>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<S>>, Step<S,S>, ByModulating, Generating<Map<K,?>,Map<K,V>>, Grouping<S,K,V>, ProfilingAware, SideEffectCapable<Map<K,?>,Map<K,V>>, TraversalParent

      public final class GroupSideEffectStep<S,K,V>
      extends SideEffectStep<S>
      implements SideEffectCapable<Map<K,?>,Map<K,V>>, TraversalParent, ByModulating, ProfilingAware, Grouping<S,K,V>

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ProfilingAware

      `ProfilingAware.ProfiledBarrier`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GroupSideEffectStep(Traversal.Admin traversal, String sideEffectKey)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `GroupSideEffectStep<S,K,V>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `Map<K,V>` | `generateFinalResult(Map<K,?> object)` Post-process the side-effect and return the post-processed side-effect.
    `Traversal.Admin<S,K>` | `getKeyTraversal()` Determines if the provided traversal is equal to the key traversal that the `Grouping` has.
    `List<Traversal.Admin<?,?>>` | `getLocalChildren()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `String` | `getSideEffectKey()` The side-effect key of the step.
    `Traversal.Admin<S,V>` | `getValueTraversal()` Determines if the provided traversal is equal to the value traversal that the `Grouping` has.
    `int` | `hashCode()`
    `void` | `modulateBy(Traversal.Admin<?,?> kvTraversal)`
    `void` | `prepareForProfiling()` Reset the `Barrier` on the step to be wrapped in a `ProfilingAware.ProfiledBarrier` which can properly start/stop the timer on the associated `ProfileStep`.
    `void` | `replaceLocalChild(Traversal.Admin<?,?> oldTraversal, Traversal.Admin<?,?> newTraversal)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `protected void` | `sideEffect(Traverser.Admin<S> traverser)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.sideEffect.SideEffectStep

      `processNextStart`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, hasStarts, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, reset, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Grouping

      `convertValueTraversal, determineBarrierStep, doFinalReduction, hasBarrierInValueTraversal`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### GroupSideEffectStep

          public GroupSideEffectStep(Traversal.Admin traversal,
                                     String sideEffectKey)

  - ### Method Detail

    - #### prepareForProfiling

          public void prepareForProfiling()

      Reset the `Barrier` on the step to be wrapped in a `ProfilingAware.ProfiledBarrier` which can properly start/stop the timer on the associated `ProfileStep`.
      Specified by:
        `prepareForProfiling` in interface `ProfilingAware`

    - #### getKeyTraversal

          public Traversal.Admin<S,K> getKeyTraversal()

      Description copied from interface: `Grouping`
      Determines if the provided traversal is equal to the key traversal that the `Grouping` has.
      Specified by:
        `getKeyTraversal` in interface `Grouping<S,K,V>`

    - #### getValueTraversal

          public Traversal.Admin<S,V> getValueTraversal()

      Description copied from interface: `Grouping`
      Determines if the provided traversal is equal to the value traversal that the `Grouping` has.
      Specified by:
        `getValueTraversal` in interface `Grouping<S,K,V>`

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> kvTraversal)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### replaceLocalChild

          public void replaceLocalChild(Traversal.Admin<?,?> oldTraversal,
                                        Traversal.Admin<?,?> newTraversal)

      Specified by:
        `replaceLocalChild` in interface `TraversalParent`

    - #### sideEffect

          protected void sideEffect(Traverser.Admin<S> traverser)

      Specified by:
        `sideEffect` in class `SideEffectStep<S>`

    - #### getSideEffectKey

          public String getSideEffectKey()

      Description copied from interface: `SideEffectCapable`
      The side-effect key of the step.
      Specified by:
        `getSideEffectKey` in interface `SideEffectCapable<Map<K,?>,Map<K,V>>`
      Returns:
        the side-effect key

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,S>`

    - #### getLocalChildren

          public List<Traversal.Admin<?,?>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,S>`
      Returns:
        the set of requirements

    - #### clone

          public GroupSideEffectStep<S,K,V> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,S>`
      Overrides:
        `clone` in class `AbstractStep<S,S>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,S>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,S>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,S>`

    - #### generateFinalResult

          public Map<K,V> generateFinalResult(Map<K,?> object)

      Description copied from interface: `Generating`
      Post-process the side-effect and return the post-processed side-effect. The default implementation is simply the identity function and returns the argument.
      Specified by:
        `generateFinalResult` in interface `Generating<Map<K,?>,Map<K,V>>`
      Parameters:
        `object` - the pre-processed side-effect.
      Returns:
        the post-processed side-effect.

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.